//PCSC Wrapp fr Labview
//Datum: 20.7.2011
//Ren Dring
//Version:01.00


#include "extcode.h"
#include <cstring>
#include <iostream>
#include <stdio.h>
#include "WINSCARD.H"
#include "PCSC_wrap.h"

using namespace std;

//*******************************************************************************************************
//Prototypen*********************************************************************************************
//*******************************************************************************************************
extern "C" __declspec (dllexport) int LV_ScardEstablishContext(unsigned long hcontexthdl,
															  unsigned long *hdl);
extern "C" __declspec (dllexport) int LV_SCardListReaders(unsigned long lContext, 
														   LStrHandle ReaderList,
														   unsigned long Zeiger);
extern "C" __declspec (dllexport) int LV_SCardConnect(unsigned long hContext, 
														   LStrHandle ReaderList, 
														   unsigned long SC_Share_Shared,
														   unsigned long Protocol_T0,
														   unsigned long *Chdl,
														   unsigned long *Zeiger);
extern "C" __declspec (dllexport) int LV_SCardStatus(unsigned long hCardHdl, 
														   LStrHandle szReader, 
														   unsigned long ReaderLeng,
														   unsigned long *dwState,
														   unsigned long *dwProtocol,
														   LStrHandle pAttr,
														   unsigned long cByte);
extern "C" __declspec (dllexport) int LV_SCardTransmitt(unsigned long hCardHdl, 
														   LStrHandle pbSend, 
														   LStrHandle pbRecv,
														   unsigned long dwRecv);
extern "C" __declspec (dllexport) int LV_SCardDisconnect(unsigned long hCardHdl, 
														   unsigned long Mode);
extern "C" __declspec (dllexport) int LV_SCardReleaseContext(unsigned long hcontexthdl);



//*******************************************************************************************************
//Initialisieren*****************************************************************************************
//*******************************************************************************************************
extern "C" __declspec (dllexport) int LV_ScardEstablishContext(unsigned long hcontexthdl,
															   unsigned long *hdl){

int i=0;

i=SCardEstablishContext(hcontexthdl,NULL,NULL,hdl);

return(i);
}

//*******************************************************************************************************
//Reader scannen*****************************************************************************************
//*******************************************************************************************************
extern "C" __declspec (dllexport) int LV_SCardListReaders(unsigned long lContext, 
														   LStrHandle ReaderList,
														   unsigned long Zeiger)	{


int i,f;//,l;
MgErr error;

char cinp1[1024]="";

//char* cinp1="";
//cinp1 = (char*) malloc(1024*sizeof(uChar)+1);


f=SCardListReadersA(lContext,0,cinp1,&Zeiger);

//l=sizeof(cinp1);

	if(error=NumericArrayResize(iB,1,(UHandle*)&ReaderList,Zeiger))	{			//Array vergrern
	goto Ausgang;														//Bei Fehler beenden
	}
	(*ReaderList)->cnt=Zeiger;

	for (i=0;i<(*ReaderList)->cnt;i++) {
	(*ReaderList)->str[i]=cinp1[i];
	}

Ausgang:
//free(cinp1);

return(f);
}

//*******************************************************************************************************
//Karte ffnen*******************************************************************************************
//*******************************************************************************************************
extern "C" __declspec (dllexport) int LV_SCardConnect(unsigned long hContext, 
														   LStrHandle ReaderList, 
														   unsigned long SC_Share_Shared,
														   unsigned long Protocol_T0,
														   unsigned long *Chdl,
														   unsigned long *Zeiger)	{


int f,i;

char inp1[512]="";
char* cinp1 = (char*) malloc((*ReaderList)->cnt*sizeof(uChar)+1);

	for (i=0; i<(*ReaderList)->cnt; ++i)
	cinp1[i] = (*ReaderList)->str[i];

cinp1[(*ReaderList)->cnt]=0;

f=SCardConnectA(hContext,cinp1,SC_Share_Shared,Protocol_T0,Chdl,Zeiger);

free(cinp1);

return(f);
}

//*******************************************************************************************************
//Karte testen*******************************************************************************************
//*******************************************************************************************************
extern "C" __declspec (dllexport) int LV_SCardStatus(unsigned long hCardHdl, 
														   LStrHandle szReader, 
														   unsigned long ReaderLeng,
														   unsigned long *dwState,
														   unsigned long *dwProtocol,
														   LStrHandle pAttr,
														   unsigned long cByte)	{

int i,f,leng;
MgErr error;
unsigned char pAtr[1024]="";
char szRead[1024]="";
/*
char inp1[512]="";
char* cinp1 = (char*) malloc((*szReader)->cnt*sizeof(uChar)+1);

	for (i=0; i<(*szReader)->cnt; ++i)
	cinp1[i] = (*szReader)->str[i];

cinp1[(*szReader)->cnt]=0;*/

f=SCardStatusA(hCardHdl,szRead,&ReaderLeng,dwState,dwProtocol,pAtr,&cByte);

	if(cByte==1024)	{
	leng=1;
	}else{
	leng=cByte;
	}

if(error=NumericArrayResize(uB,1,(UHandle*)&pAttr,leng))	{			//Array vergrern
	goto Ausgang;														//Bei Fehler beenden
	}
	(*pAttr)->cnt=leng;

	for (i=0;i<(*pAttr)->cnt;i++) {
	(*pAttr)->str[i]=pAtr[i];
	}

	if(error=NumericArrayResize(iB,1,(UHandle*)&szReader,ReaderLeng))	{			//Array vergrern
	goto Ausgang;														//Bei Fehler beenden
	}
	(*szReader)->cnt=ReaderLeng;

	for (i=0;i<(*szReader)->cnt;i++) {
	(*szReader)->str[i]=szRead[i];
	}

Ausgang:

return(f);
}

//*******************************************************************************************************
//APDU senden********************************************************************************************
//*******************************************************************************************************
extern "C" __declspec (dllexport) int LV_SCardTransmitt(unsigned long hCardHdl, 
														   LStrHandle pbSend, 
														   LStrHandle pbRecv,
														   unsigned long dwRecv)	{

SCARD_IO_REQUEST T1_request;
int f,i,leng;
MgErr error;
unsigned char Recv[1024]="";

T1_request.dwProtocol=SCARD_PROTOCOL_T1;
T1_request.cbPciLength=8;

f=SCardTransmit(hCardHdl,&T1_request,((*pbSend)->str),(*pbSend)->cnt,0,Recv,&dwRecv);

	if(dwRecv==1024)	{
	leng=1;
	}else{
	leng=dwRecv;
	}

if(error=NumericArrayResize(uB,1,(UHandle*)&pbRecv,leng))	{			//Array vergrern
	goto Ausgang;														//Bei Fehler beenden
	}
	(*pbRecv)->cnt=leng;

	for (i=0;i<(*pbRecv)->cnt;i++) {
	(*pbRecv)->str[i]=Recv[i];
	}

Ausgang:

return(f);

}

//*******************************************************************************************************
//Karte beenden******************************************************************************************
//*******************************************************************************************************
extern "C" __declspec (dllexport) int LV_SCardDisconnect(unsigned long hCardHdl, 
														   unsigned long Mode)	{
/*
#define SCARD_LEAVE_CARD      0 // Don't do anything special on close
#define SCARD_RESET_CARD      1 // Reset the card on close
#define SCARD_UNPOWER_CARD    2 // Power down the card on close
#define SCARD_EJECT_CARD      3 // Eject the card on close*/

int f;

f=SCardDisconnect(hCardHdl,Mode);


return(f);
}

//*******************************************************************************************************
//Deinit*************************************************************************************************
//*******************************************************************************************************
extern "C" __declspec (dllexport) int LV_SCardReleaseContext(unsigned long hcontexthdl)	{

int f;

f=SCardReleaseContext(hcontexthdl);


return(f);
}